local ADDON, namespace = ...
local L = namespace.L
local tooltip
local arg = {}

local prgname = "|cffffd200"..ADDON.."|r"
local checkbox = {}

local LeftButton = " |TInterface\\TUTORIALFRAME\\UI-TUTORIAL-FRAME:13:11:0:-1:512:512:12:66:230:307|t "
local RightButton = " |TInterface\\TUTORIALFRAME\\UI-TUTORIAL-FRAME:13:11:0:-1:512:512:12:66:333:411|t "
local MiddleButton = " |TInterface\\TUTORIALFRAME\\UI-TUTORIAL-FRAME:13:11:0:-1:512:512:12:66:127:204|t "

local chanName = {"LDB","SELF","GROUP"}
local deaths = {}

local LibQTip = LibStub('LibQTip-1.0')
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
 
local dataobj = ldb:NewDataObject(ADDON, {
    type = "data source",
    icon = "Interface\\Addons\\"..ADDON.."\\icon.tga",
    text = "-"
})

local frame = CreateFrame("Frame")

--- Defining local functions -----------------------------------------------------------

local function classcolor(destName)
	if not UnitExists(destName) then return string.format("\124cffff0000%s\124r", destName) end
	local _, class = UnitClass(destName)
	local color = _G["RAID_CLASS_COLORS"][class]
	return string.format("\124cff%02x%02x%02x%s\124r", color.r*255, color.g*255, color.b*255, destName)
end

local function number(v)
	if v <= 9999 then return v	
	elseif v >= 1000000 then return format("%.1fM", v/1000000)
	elseif v >= 10000 then return format("%.1fK", v/1000)
	end
end

local function unescape(String)
	local Result = tostring(String)
	Result = gsub(Result, "|H.-|h(.-)|h", "%1") -- Remove links.
	Result = gsub(Result, "%[", "") -- Remove links.
	Result = gsub(Result, "%]", "") -- Remove links.
	-- Result = gsub(Result, "%-[^|]+", "")
	return Result
end

local function unescape2(String)
	local Result = tostring(String)
	Result = gsub(Result, "%[", "") -- Remove links.
	Result = gsub(Result, "%]", "") -- Remove links.
	-- Result = gsub(Result, "%-[^|]+", "")
	return Result
end

local function OnRelease_legenda(self)
	LibQTip:Release(self.tooltip_legenda)
	self.tooltip_legenda = nil  
end  
 
local function OnLeave_legenda(self)
	if self.tooltip_legenda and not self.tooltip_legenda:IsMouseOver() then
		self.tooltip_legenda:Release()
	end
end  

local function ShowLegenda(self)
	arg = {}

	LibQTip:Release(tooltip_legenda)
	tooltip_legenda = nil  

	local row,col
    tooltip_legenda = LibQTip:Acquire(ADDON.."tip_legenda", 2, "LEFT","RIGHT")
	self.tooltip_legenda = tooltip_legenda
    tooltip_legenda:SmartAnchorTo(self)
	tooltip_legenda:EnableMouse(true)
	tooltip_legenda.OnRelease = OnRelease_legenda
	tooltip_legenda.OnLeave = OnLeave_legenda
    tooltip_legenda:SetAutoHideDelay(.1, self)
	tooltip_legenda:SetScale(GMAUTOPSY_CFG["SCALE"])
	
 	row,col = tooltip_legenda:AddLine("")
	
	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,_G["KNOWLEDGE_BASE"],"CENTER",2)
	
	row,col = tooltip_legenda:AddLine("")	
	row,col = tooltip_legenda:AddLine("")		

	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,_G["PLAYER"],"CENTER",2)
	row,col = tooltip_legenda:AddSeparator()
	
	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,LeftButton)
	tooltip_legenda:SetCell(row,2,"|cffffd200" .. L["Show Spell"] .. "|r")

	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,RightButton)
	tooltip_legenda:SetCell(row,2,"|cffffd200" .. L["Whisp Player"] .. "|r")

	row,col = tooltip_legenda:AddLine("")	
	row,col = tooltip_legenda:AddLine("")		

	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,L["DataBroker"],"CENTER",2)
	row,col = tooltip_legenda:AddSeparator()
	row,col = tooltip_legenda:AddLine()

	row,col = tooltip_legenda:AddLine("")	
	row,col = tooltip_legenda:AddLine("")		

	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,LeftButton)
	tooltip_legenda:SetCell(row,2,"|cffffd200" .. L["Channel"] .. "|r")

	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,RightButton)
	tooltip_legenda:SetCell(row,2,"|cffffd200" .. L["Report on|off"] .. "|r")

	row,col = tooltip_legenda:AddLine("")		
	row,col = tooltip_legenda:AddLine("")		

	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,_G["SHIFT_KEY"] .. " " .. LeftButton)
	tooltip_legenda:SetCell(row,2,"|cffffd200 - " .. _G["UI_SCALE"] .. "|r")

	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,_G["SHIFT_KEY"] .. " " ..RightButton)
	tooltip_legenda:SetCell(row,2,"|cffffd200 + " .. _G["UI_SCALE"] .. "|r")

	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,_G["SHIFT_KEY"] .. " " ..MiddleButton)
	tooltip_legenda:SetCell(row,2,"|cffffd200 1.0 " .. _G["UI_SCALE"] .. "|r")

	row,col = tooltip_legenda:AddLine("")		
	row,col = tooltip_legenda:AddLine("")		

	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,_G["ALT_KEY"] .. " " ..LeftButton)
	tooltip_legenda:SetCell(row,2,"|cffffd200" .. _G["KNOWLEDGE_BASE"] .. "|r")
	
	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,_G["ALT_KEY"] .. " " ..MiddleButton)
	tooltip_legenda:SetCell(row,2,"|cffffd200" .. _G["RESET"] .. "|r")

	row,col = tooltip_legenda:AddLine()
	tooltip_legenda:SetCell(row,1,_G["ALT_KEY"] .. " " ..RightButton)
	tooltip_legenda:SetCell(row,2,"|cffffd200" .. L["Demo"] .. "|r")

	tooltip_legenda:Show()
end

local function demoToolTip()
	local deaths = {}
	for i=1,15 do
		local sources = {"Udvud il macellaio", "Brown Marmot", "Wolf", "Black Mamba", "Calamir", "Umongris", "Drugon il Sangue Gelido"}
		local damages = {"Melee", 30455, 219602, 219349, 216043, 213590, 223689}
		local damage = damages[math.random(7)]
		
		if damage == "Melee" then 
			deaths[#deaths+1] = {
				timestamp 	= date("%H:%M:%S",timestamp),
				sourceName 	= sources[math.random(7)],
				destName 	= UnitName("player"),
				spell 		= "Melee",
				damage		= number(math.random(500000,2000000)),
				overkill	= number(math.random(500000))
			}
		else
			deaths[#deaths+1] = {
				timestamp 	= date("%H:%M:%S",timestamp),
				sourceName 	= sources[math.random(7)],
				destName 	= UnitName("player"),
				spell 		= GetSpellLink(damage),
				damage		= number(math.random(500000,2000000)),
				overkill	= number(math.random(500000))
			}
		end
	end
	return deaths
end

local function UpdateLDB()
	if GMAUTOPSY_CFG["ENABLED"] == false then
		dataobj.icon = "Interface\\Addons\\"..ADDON.."\\icon-off.tga"
		dataobj.text = string.format("|cffff0000%s|r", "OFF")
		frame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	else 
		dataobj.icon = "Interface\\Addons\\"..ADDON.."\\icon.tga"
		dataobj.text = string.format("|cff00ff00%s|r", chanName[GMAUTOPSY_CFG["CHANNEL"]])
		frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	end
end

local function OnRelease(self)
	LibQTip:Release(self.tooltip)
	self.tooltip = nil
end  

local function Button_OnClick(row, arg, button)
   
   	LibQTip:Release(tooltip)
	tooltip = nil  
   
   	if button == "RightButton" then
	
		SendChatMessage(string.format(L["You was killed by %s with %s overkill %s"],arg.spell,arg.damage,arg.overkill),"WHISPER", nil, arg.destName)
		
	elseif button == "LeftButton" then

		if arg.spell == "Melee" then return end
		
		ShowUIPanel(ItemRefTooltip)
		
		if not ItemRefTooltip:IsShown() then
			
			ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE")

		end
			
		ItemRefTooltip:SetHyperlink(arg.spell)		
		return

	elseif button == "MiddleButton" then
	-- nop
	end
end

local function anchor_OnEnter(self)

	arg = {}

	if self.tooltip then
		LibQTip:Release(self.tooltip)
		self.tooltip = nil  
	end
    local row,col
    local tooltip = LibQTip:Acquire(ADDON.."tip", 6,"LEFT","LEFT","LEFT","LEFT","RIGHT","RIGHT")
    self.tooltip = tooltip 
    tooltip:SmartAnchorTo(self)
	tooltip:EnableMouse(true)
	tooltip.OnRelease = OnRelease
	tooltip.OnLeave = OnLeave
    tooltip:SetAutoHideDelay(.1, self)
	tooltip:SetScale(GMAUTOPSY_CFG["SCALE"])
 	
	row,col = tooltip:AddLine("")
	row,col = tooltip:AddLine("")
 
	if #deaths > 0 then 

		row,col = tooltip:AddLine()
		tooltip:SetCell(row,1,L["Deaths Reports"],"CENTER",6)
		tooltip:SetColumnTextColor(1,1,1,0)
		row,col = tooltip:AddLine("")
	
		row,col = tooltip:AddLine()
		tooltip:SetCell(row,1,L["Time"])
		tooltip:SetCell(row,2,L["Source"])
		tooltip:SetCell(row,3,L["Target"])
		tooltip:SetCell(row,4,L["Spell"])
		tooltip:SetCell(row,5,L["Damage"])
		tooltip:SetCell(row,6,L["Overkill"])
		tooltip:SetLineTextColor(row, 1, 1, 0)

		-- deaths=demoToolTip()
		
		for i=1, #deaths do
			row,col = tooltip:AddLine()
			tooltip:SetCell(row,1,deaths[i]["timestamp"])
			tooltip:SetCell(row,2,deaths[i]["sourceName"])
			tooltip:SetCell(row,3,classcolor(deaths[i]["destName"]))
			tooltip:SetCell(row,4,deaths[i]["spell"])
			tooltip:SetCell(row,5,deaths[i]["damage"])
			tooltip:SetCell(row,6,deaths[i]["overkill"])
			
			arg[row] = { 
				timestamp=deaths[i]["timestamp"],
				sourceName=deaths[i]["sourceName"],
				destName=deaths[i]["destName"],
				spell=deaths[i]["spell"],
				damage=deaths[i]["damage"],
				overkill=deaths[i]["overkill"],
				tooltip=tooltip
			}
			tooltip:SetLineScript(row, 'OnMouseUp', Button_OnClick, arg[row])
		end
	else 
		row,col = tooltip:AddLine()
		tooltip:SetCell(row,1,L["No deaths recorded yet"],"CENTER",6)
	end

	row,col = tooltip:AddLine("")
	row,col = tooltip:AddLine("")
	
	row,col = tooltip:AddLine()
	tooltip:SetCell(row,3,_G["ALT_KEY"] .. " " .. LeftButton .. prgname .. " |cffffd200" .. _G["KNOWLEDGE_BASE"] .. "|r","RIGHT",4,0,10)

	tooltip:UpdateScrolling(GetScreenHeight()-50)
    row,col = tooltip:Show()
end
 
dataobj.OnEnter = function(self)
    anchor_OnEnter(self)
end
 
dataobj.OnLeave = function(self)
    -- Null operation: Some LDB displays get cranky if this method is missing.
end

function dataobj.OnClick(self, button)
	
if InCombatLockdown() then return end

	local config_changed = false
	
	LibQTip:Release(self.tooltip_legenda)
	self.tooltip_legenda = nil  

	LibQTip:Release(self.tooltip)
	self.tooltip = nil

	if IsShiftKeyDown() then 	
		if button == "LeftButton" then	
			if GMAUTOPSY_CFG["SCALE"] < 0.8 then return end
			GMAUTOPSY_CFG["SCALE"] = GMAUTOPSY_CFG["SCALE"] - 0.05
			config_changed = true
		end

		if button == "RightButton" then 
			if GMAUTOPSY_CFG["SCALE"] > 2 then return end
			GMAUTOPSY_CFG["SCALE"] = GMAUTOPSY_CFG["SCALE"] + 0.05
			config_changed = true
		end
		
		if button == "MiddleButton" then 
			GMAUTOPSY_CFG["SCALE"] = 1
			config_changed = true
		end
	end

	if 	IsAltKeyDown() then
		if 	button == "LeftButton" then 
			ShowLegenda(self)
		end
		
		if button == "RightButton" then
			deaths=demoToolTip()
		end
		
		if button == "MiddleButton" then 
			deaths = {}
		end
	end	


	if not IsModifierKeyDown() then 

		if button == "LeftButton" and GMAUTOPSY_CFG["ENABLED"] == true then
			if (GMAUTOPSY_CFG["CHANNEL"] == 3) then 					
				GMAUTOPSY_CFG["CHANNEL"] = 1
			else
				GMAUTOPSY_CFG["CHANNEL"] = GMAUTOPSY_CFG["CHANNEL"] + 1
			end
			-- config_changed = true
		end
	
		if button == "RightButton" then	
			GMAUTOPSY_CFG["ENABLED"] = not GMAUTOPSY_CFG["ENABLED"]
			-- config_changed = true
		end
	end	
	
	UpdateLDB()

	if config_changed == true then 
		print(string.format("|cFFFFFF00%s|r config: scale %s",ADDON,GMAUTOPSY_CFG["SCALE"]))
	end	
	
end

-- Configuration Panel ----------------------------------------------------------------------------
local options = CreateFrame("Frame", "options", InterfaceOptionsFramePanelContainer)
options.name = GetAddOnMetadata(ADDON, "Title") or ADDON
InterfaceOptions_AddCategory(options)

-- Title (title)
local title = options:CreateFontString("$parentTitle", "ARTWORK", "GameFontNormalLarge")
title:SetPoint("TOPLEFT", 16, -16)
title:SetText(options.name)
options.title = title

-- SubTitle (subtitle)
local subtext = options:CreateFontString("$parentSubText", "ARTWORK", "GameFontHighlightSmall")
subtext:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)
subtext:SetPoint("RIGHT", -32, 0)
subtext:SetHeight(32)
subtext:SetJustifyH("LEFT")
subtext:SetJustifyV("TOP")
subtext:SetText(GetAddOnMetadata(ADDON, "Notes"))
options.subtext = subtext

-- Title (title)
local title = options:CreateFontString("$parentTitle", "ARTWORK", "GameFontHighlightSmall")
title:SetPoint("TOPLEFT", 18, -85 -(30*1))
title:SetText(_G["DEATHS_COMBATLOG_TOOLTIP"])

checkbox[1] = CreateFrame("CheckButton", "$parentEnable", options, "InterfaceOptionsCheckButtonTemplate")
checkbox[1]:SetPoint("TOPLEFT", 18, (-70 -(30*2)))
checkbox[1].Text:SetText(_G["DEATHS"])
checkbox[1]:SetScript("OnClick", function(self)
	if checkbox[1]:GetChecked() then
		GMAUTOPSY_CFG["DEATHS"] = true
	else 
		GMAUTOPSY_CFG["DEATHS"] = false
	end	
end)


-- Title (title)
local title = options:CreateFontString("$parentTitle", "ARTWORK", "GameFontHighlightSmall")
title:SetPoint("TOPLEFT", 18, -85 - (30*3))
title:SetText(_G["DISPEL_AURA_COMBATLOG_TOOLTIP"])

checkbox[2] = CreateFrame("CheckButton", "$parentEnable", options, "InterfaceOptionsCheckButtonTemplate")
checkbox[2]:SetPoint("TOPLEFT", 18, (-70 - (30*4)))
checkbox[2].Text:SetText(_G["INTERRUPTS"])
checkbox[2]:SetScript("OnClick", function(self)
	if checkbox[2]:GetChecked() then
		GMAUTOPSY_CFG["INTERRUPTS"] = true
	else 
		GMAUTOPSY_CFG["INTERRUPTS"] = false
	end	
end)

checkbox[3] = CreateFrame("CheckButton", "$parentEnable", options, "InterfaceOptionsCheckButtonTemplate")
checkbox[3]:SetPoint("TOPLEFT", 18, (-70 - (30*5)))
checkbox[3].Text:SetText(_G["DISPELS"])
checkbox[3]:SetScript("OnClick", function(self)
	if checkbox[3]:GetChecked() then
		GMAUTOPSY_CFG["DISPELS"] = true
	else 
		GMAUTOPSY_CFG["DISPELS"] = false
	end	
end)

-- Reset and Reload
local button1 = CreateFrame("button", button1, options, "UIPanelButtonTemplate")
button1:SetHeight(40)
button1:SetWidth(150)
button1:SetPoint("BOTTOMLEFT", 10, 16)
button1:SetText("Reset and reload UI")
button1.tooltipText = "BEWARE: Reset your custom settings and reload your UI"
button1:SetScript("OnClick",  
	function()
		GMAUTOPSY_CFG = {}
		ReloadUI()
	end)  
	
-- Save & Reload
local button2 = CreateFrame("button", button2, options, "UIPanelButtonTemplate")
button2:SetHeight(40)
button2:SetWidth(150)
button2:SetPoint("BOTTOMLEFT", 190, 16)
button2:SetText("Save and reload UI")
button2.tooltipText = "Save your custom settings and reload UI"
button2:SetScript("OnClick",  
	function()
		ReloadUI()
	end)  	
	
--- Credits  
local credits = options:CreateFontString("$parentTitle", "ARTWORK", "SystemFont_Small")
credits:SetPoint("BOTTOMRIGHT", -16, 16)
credits:SetText("version: |cffffd200"..GetAddOnMetadata(ADDON, "Version").."|r by |cffffd200"..GetAddOnMetadata(ADDON, "Author").."|r")
options.credits = credits	

function options.refresh()
		checkbox[1]:SetChecked(GMAUTOPSY_CFG["DEATHS"])
		checkbox[2]:SetChecked(GMAUTOPSY_CFG["INTERRUPTS"])
		checkbox[3]:SetChecked(GMAUTOPSY_CFG["DISPELS"])
end

-- Manage EVENTS -----------------------------------------------------------------------
frame:RegisterEvent("PLAYER_LOGIN")
frame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:SetScript("OnEvent", function(self, event, ...)
	
	-- defaults
	if event == "PLAYER_ENTERING_WORLD" then 
		local GMAUTOPSY_DEFAULTS = { MAXREP=35, ENABLED=true,	CHANNEL=1, SCALE=1, DEATHS=true, INTERRUPTS=true, DISPELS=true, STEALS=true} 
		GMAUTOPSY_CFG = GMAUTOPSY_CFG or {}
		for k in pairs(GMAUTOPSY_DEFAULTS) do
			if GMAUTOPSY_CFG[k] == nil then GMAUTOPSY_CFG[k] = GMAUTOPSY_DEFAULTS[k] end
		end	
		local playerGUID = UnitGUID("player")

		checkbox[1]:SetChecked(GMAUTOPSY_CFG["DEATHS"])
		checkbox[2]:SetChecked(GMAUTOPSY_CFG["INTERRUPTS"])
		checkbox[3]:SetChecked(GMAUTOPSY_CFG["DISPELS"])

		UpdateLDB()	
	end
	
	if event == "ZONE_CHANGED_NEW_AREA" then	
		UpdateLDB()
	end
	
	-- Parsing COMBAT_LOG_EVENT_UNFILTERED
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then

		local timestamp,clevent,_,sourceGUID,sourceName,sourceFlags,_,destGUID,destName,destFlags,_,prefixParam1,prefixParam2,_,suffixParam1,suffixParam2 = CombatLogGetCurrentEventInfo()
		local autopsy_msg = nil
		local p_autopsy_msg = nil
		local isDeath, isKick, isDispel = false
		
		-- check if source was a player/pet in our party/raid
		if (destGUID == playerGUID or (destName and UnitClass(destName))) and destGUID:sub(1,3) ~= "Pet" then
			
			sourceName = sourceName or "Unknown"
			
			if clevent == "SWING_DAMAGE" then
				if prefixParam2 > 0 then 
					prefixParam1 = number(prefixParam1)
					prefixParam2 = number(prefixParam2)
					p_autopsy_msg = string.format(L["%s: %s killed %s with %s melee overkill %s"],prgname,sourceName, classcolor(destName), prefixParam1, prefixParam2)
					autopsy_msg = string.format(L["%s: %s killed %s with %s melee overkill %s"],ADDON,sourceName, destName, prefixParam1, prefixParam2)
					isDeath = true
					deaths[#deaths+1] = {
						timestamp 	= date("%H:%M",timestamp),
						sourceName 	= sourceName,
						destName 	= destName,
						spell 		= _G["ACTION_SWING"],
						damage		= prefixParam1,
						overkill	= prefixParam2
					}					
				end	
			end 
			
			if clevent == "SPELL_DAMAGE" or clevent == "SPELL_PERIODIC_DAMAGE" or clevent == "RANGE_DAMAGE" then
				if suffixParam2 > 0 then
					suffixParam1 = number(suffixParam1)
					suffixParam2 = number(suffixParam2)
					p_autopsy_msg = string.format(L["%s: %s killed %s with %s damage of %s overkill %s"],prgname, sourceName, classcolor(destName),suffixParam1,GetSpellLink(prefixParam1),suffixParam2)
					autopsy_msg = string.format(L["%s: %s killed %s with %s damage of %s overkill %s"],ADDON, sourceName, destName,suffixParam1,GetSpellLink(prefixParam1),suffixParam2)
					isDeath = true
					deaths[#deaths+1] = {
						timestamp 	= date("%H:%M",timestamp),
						sourceName 	= sourceName,
						destName 	= destName,
						spell 		= GetSpellLink(prefixParam1),
						damage		= suffixParam1,
						overkill	= suffixParam2
					}					
				end				
			end	
			if #deaths >= GMAUTOPSY_CFG["MAXREP"] then table.remove(deaths, 1) end
			
			
		end
		
		-- someone kicks, steals and dispels something 
		-- if (inRaid and bit.band(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_RAID) ~= 0) or (inGroup and bit.band(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_PARTY) ~= 0) then
		if (sourceGUID == playerGUID or (sourceName and UnitClass(sourceName))) and sourceGUID:sub(1,3) ~= "Pet" then
	
			local usedSpell = ""
			if GetSpellLink(prefixParam2) then 
				usedSpell = "with " .. GetSpellLink(prefixParam2)
			end

			if clevent=="SPELL_DISPEL" then
				p_autopsy_msg = string.format(L["%s: %s dispelled %s %s %s"],prgname,classcolor(sourceName), destName, GetSpellLink(suffixParam1) or suffixParam2, usedSpell)
				autopsy_msg = string.format(L["%s: %s dispelled %s %s %s"],ADDON,sourceName, destName, GetSpellLink(suffixParam1), usedSpell)
				isDispel = true
			end
			
			if clevent=="SPELL_STOLEN" then
				p_autopsy_msg = string.format(L["%s: %s stole %s %s %s"],prgname,classcolor(sourceName), destName, GetSpellLink(suffixParam1) or suffixParam2, usedSpell)
				autopsy_msg = string.format(L["%s: %s stole %s %s %s"],ADDON,sourceName, destName, GetSpellLink(suffixParam1) or suffixParam2, usedSpell)
				isDispel = true
			end
			
			if clevent=="SPELL_INTERRUPT" then 
				p_autopsy_msg = string.format("%s: %s interrupted %s %s %s",prgname,classcolor(sourceName), destName, GetSpellLink(suffixParam1) or suffixParam2, usedSpell)
				autopsy_msg = string.format("%s: %s interrupted %s %s %s",ADDON,sourceName, destName, GetSpellLink(suffixParam1), usedSpell)
				isKick = true
			end	
		end

		-- if we have a msg to display and we want see
		if autopsy_msg and ((isDeath and GMAUTOPSY_CFG["DEATHS"]) or (isKick and GMAUTOPSY_CFG["INTERRUPTS"]) or (isDispel and  GMAUTOPSY_CFG["DISPELS"])) then 
			-- print("DEBUG : " .. (isDeath and "death true" or "death false") .. ":" .. (isDispel and "dispel true" or "dispel false") .. ":" .. (isKick and "kick true" or "kick false"))
			
			if GMAUTOPSY_CFG["CHANNEL"] == 3 then				
				if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
					SendChatMessage(autopsy_msg, "INSTANCE_CHAT")
				elseif IsInRaid() then
					SendChatMessage(autopsy_msg, "RAID")
				elseif IsInGroup() then
					SendChatMessage(autopsy_msg, "PARTY")
				else
					print(p_autopsy_msg)
				end
			end
				
			if GMAUTOPSY_CFG["CHANNEL"] == 2 then 
				print(p_autopsy_msg)	
			end 
		end
	end	
end)